
#include "TCS34725.h"
#include "delay.h"
#include "usart.h"

//IO
#define SDA1_IN()  {GPIOC->CRH&=0XFFFFF0FF;GPIOC->CRH|=8<<8;}//Ϊģʽ
#define SDA1_OUT() {GPIOC->CRH&=0XFFFFF0FF;GPIOC->CRH|=3<<8;}//Ϊģʽ

//IO	 
#define IIC1_SCL    PCout(9) //SCL
#define IIC1_SDA    PCout(10) //SDA	 
#define READ1_SDA   PCin(10)  //SDA 


#define  SDA_TCS34725_IN     {GPIOC->CRH&=0XFFFFF0FF;GPIOC->CRH|=8<<8;}  //SET  IN
#define  SDA_TCS34725_OUT    {GPIOC->CRH&=0XFFFFF0FF;GPIOC->CRH|=3<<8;} //SET  OUT

#define Read_TCS34725_SDA  GPIO_ReadInputDataBit(GPIOC,GPIO_Pin_10)//ȡֵ

#define  SDA_H         GPIO_SetBits  (GPIOC,GPIO_Pin_10)  //á1
#define  SDA_L         GPIO_ResetBits(GPIOC,GPIO_Pin_10)   //塰0
#define  SCL_H         GPIO_SetBits  (GPIOC,GPIO_Pin_9)   //á1
#define  SCL_L         GPIO_ResetBits(GPIOC,GPIO_Pin_9)  //塰0
//
_TCS3472_HSL _TCS3472_HSL_DATA;
//
void Color_tcs34725_Init(void);
void TCS34725_Write_addr(u8 Address, u8 dat);
u8 TCS34725_Read_addr(u8 Address);
void Capture_RGB(void);
void White_Banlance_Init(void);
void Printf_ColorRGB(void);
//ڲ
void I2CStart(void);
void I2Cask(void);
void I2CStop(void);
void I2CWrByte(u8 oneByte);
void IIC_MASTERACK (void);

/*************************************************
             I2Cƺ
*************************************************/
//ʼ
void Port_Init(void) //IOʼ
{ 
 	GPIO_InitTypeDef GPIO_InitStructure;
 
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC|RCC_APB2Periph_GPIOC,ENABLE);//ʹPORTA,PORTEʱ
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_9|GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOC, &GPIO_InitStructure);

}

void I2CStart(void)//ʼź
{
		SDA_TCS34725_OUT;
    SCL_H;
    delay_us(5);
    SDA_H;
    delay_us(5);
    SDA_L;
    delay_us(5);
    SCL_L;
}
void I2CStop(void) //ֹͣź
{
		SDA_TCS34725_OUT;
    SDA_L;
    delay_us(5);
    SCL_H;
    delay_us(5);
    SDA_H;
    delay_us(5);
    SCL_L;
    delay_us(5);
    SDA_L;
    delay_us(5);
}

void I2Cask(void) //ACKź
{
    u8 timeout = 1;
    SDA_TCS34725_IN;          //SDAתΪ
    SCL_L;
    while((Read_TCS34725_SDA) && (timeout <= 10)) //ȴSDAء0ƽ
    {
        timeout++;
    }
    SCL_H;
    delay_us(5);
    SCL_L;
    SDA_TCS34725_OUT;          //SDAתΪ
}
/*******************************************************************************
*            :IIC_MASTERACK()
*          :MCUӦź        
*              :
*              :
*******************************************************************************/ 
void IIC_MASTERACK (void)//Ӧź
{
  
		SDA_TCS34725_OUT;    
    SCL_L;
    delay_us(5);
    SDA_L;
    delay_us(5);
    SCL_H;
    delay_us(5);
    SCL_L;
    delay_us(5);      
}
void I2CWrByte(u8 oneByte) //дһֽڸλǰλں
{
    u8 i;
		SDA_TCS34725_OUT;
    SCL_L;
    for(i = 0; i < 8; i++)
    {
        if(oneByte & 0x80)
            SDA_H;
        else
            SDA_L;

        delay_us(5);
        SCL_H;
        delay_us(5);
        SCL_L;
        oneByte <<= 1;
    }
}
u8 I2CReadByte() //дһֽڸλǰλں
{
    u8 dat, i;
    dat = 0;
    SDA_TCS34725_IN;          //SDAתΪ		
    SCL_L;
    for(i = 0; i < 8; i++)
    {
        SCL_H;
        dat = dat << 1;
        if(Read_TCS34725_SDA)
        {
            dat++;
        }
        delay_us(5);
        SCL_L;
        delay_us(5);
    }
		SDA_TCS34725_OUT;
    return dat ;
}

void TCS34725_Write_addr(u8 Address,u8 dat) //
{
    I2CStart();
    I2CWrByte(COLOR_ADDR_Device); 
    I2Cask();
    I2CWrByte(Address);	
    I2Cask();
    I2CWrByte(dat);
    I2Cask();
    I2CStop();
}

u8 TCS34725_Read_addr(u8 Address)  //
{
		u8 rev;

    I2CStart();
    I2CWrByte(COLOR_ADDR_Device);
    I2Cask();
		I2CWrByte(Address);
		I2Cask();
		I2CStart();
		I2CWrByte(COLOR_ADDR_Device|0x01);	
    I2Cask();
		rev = I2CReadByte();
    I2CStop();
    return(rev);
}

_RGBC_V RGB_V;
void Capture_RGB(void)
{
	u8 i,count=3;
	u8 status;
	u16 tt[4];
	u32 r=0,g=0,b=0,c=0;
	TCS34725_Write_addr(COLOR_ADDR_WTIME,0xFF);		//õȴʱ2.4ms
	TCS34725_Write_addr(COLOR_ADDR_ATIME,0xF6);		//üʱ
	TCS34725_Write_addr(COLOR_ADDR_CONTROL,0x02);	//RGBֵ汶	
	for(i=0;i<count;i++)
	{
		TCS34725_Write_addr(COLOR_ADDR_ENABLE,0x0B);//ݲɼ
		delay_ms(30);//ʱҪ
		status = TCS34725_Read_addr(COLOR_ADDR_ENABLE) & ~0x02;
		TCS34725_Write_addr(COLOR_ADDR_ENABLE,status);
		
    I2CStart();
    I2CWrByte(COLOR_ADDR_Device);
    I2Cask();
		I2CWrByte(COLOR_ADDR_CDATAL);
		I2Cask();
		I2CStart();
		I2CWrByte(COLOR_ADDR_Device|0x01);	
		I2Cask();
		tt[0] = I2CReadByte();
		IIC_MASTERACK();
		tt[0] |= I2CReadByte()<<8;
		IIC_MASTERACK();
		tt[1] = I2CReadByte();
		IIC_MASTERACK();
		tt[1] |= I2CReadByte()<<8;
		IIC_MASTERACK();
		tt[2] = I2CReadByte();
		IIC_MASTERACK();
		tt[2] |= I2CReadByte()<<8;
		IIC_MASTERACK();
		tt[3] = I2CReadByte();
		IIC_MASTERACK();
		tt[3] |= I2CReadByte()<<8;
		I2CStop();
		
		c += tt[0];
		r += tt[1];
		g += tt[2];
		b += tt[3];
	}
	RGB_V.Green = g/count;	
	RGB_V.Blue = b/count;
	RGB_V.Red = r/count;
	RGB_V.Clear = c/count;	
}
//ƽݲɼ
_WhiteBanlance_Gene GENE={451,596,511,1570};		//ʼֵ
void White_Banlance_Init(void)
{
	Capture_RGB();
	GENE.Rgene = RGB_V.Red;
	GENE.Ggene = RGB_V.Green;
	GENE.Bgene = RGB_V.Blue;
	GENE.Cgene = RGB_V.Clear;
}

_TCS3472_RGBC RGB;
void Printf_ColorRGB(void)
{
	Capture_RGB();
	RGB.Red = RGB_V.Red*255/GENE.Rgene;
	RGB.Green = RGB_V.Green*255/GENE.Ggene;
	RGB.Blue = RGB_V.Blue*255/GENE.Bgene;
	
	if(RGB.Red>255)		RGB.Red = 255;
	if(RGB.Green>255)	RGB.Green = 255;
	if(RGB.Blue>255)	RGB.Blue = 255;	
	printf("\r\nɫ=%xɫ=%x,ɫ=%x\r\n",RGB.Red,RGB.Green,RGB.Blue);
	
}
void Color_tcs34725_Init(void)
{
	Port_Init();
	TCS34725_Write_addr(COLOR_ADDR_WTIME,0xFF);		//õȴʱ2.4ms
	TCS34725_Write_addr(COLOR_ADDR_ATIME,0xF6);		//üʱ24msֵ10240
	TCS34725_Write_addr(COLOR_ADDR_CONTROL,0x02);	//RGBֵ汶
	TCS34725_Write_addr(COLOR_ADDR_ENABLE,0x09);	//رղɼͨ
}
